/*
ADC-Messung M16/M32

Alle ADC-Kanle werden fortlaufend gemessen und im Interrupt ausgelesen.
Fr jeden Kanal wird erst die "dummy conversion" ausgefhrt, dann zwin der Mittelwert aus den nchsten beiden Messungen gebildet.

Die Ergebnisse werden in adcwerte[] abgelegt.

22.10.2008: erstellt

Status: nur externe Referenz getestet!
*/
#include "autoadc.h"


/* Array mit den ADC-Werten, 16bit*/
volatile uint16_t adcwerte[8];

/* automatische Messung starten*/
void start_autoADC(void)
{

if(!(ADCSRA & (1<<ADEN))) // prfen ob schon aktiv
	{

	#if REFERENCE == EXTERNAL
		ADMUX &= ~(1<<REFS0)|(1<<REFS1);
	#endif
	
	#if REFERENCE == AVCC
		ADMUX |= (1<<REFS0);
	#endif
	
	#if REFERENCE == INTERNAL
		ADMUX |= (1<<REFS0)|(1<<REFS1);
	#endif
	
	
	//enable ADC, start Conversion, enable ADC interrupt, Prescaler 128 -> 125kHz ADC clock
	ADCSRA |= (1<<ADEN) | (1<<ADSC) | (1<<ADIE) | (1<<ADPS2) | (1<<ADPS1)|(1<<ADPS2);
	}
}

/*automatische Messung beenden*/
void stop_autoADC(void)
{
	//diable ADC, disable interrupt
	ADCSRA &= ~(1<<ADEN)|(1<<ADIE);
}



 volatile uint8_t chan=0;
 volatile uint8_t measurement=1; 
 volatile uint16_t tmp=0;

ISR (ADC_vect)
{

switch(measurement)
	{

	case 1:
		//erste Messung verwerfen
		//zweite Messung starten
		ADCSRA|=(1<<ADSC);
	break;
	
	case 2:
		//zweite Messung auswerten, aufintegrieren
		tmp=ADC; 
		//dritte Messung starten
		ADCSRA|=(1<<ADSC);
	break;

	case 3:
		//zweite Messung auswerten, aufintegrieren
		tmp+=ADC; 
		
		adcwerte[chan]= tmp/2;
		
		//Kanal wechseln
		chan++;
		if(chan>7) chan=0;
		
		ADMUX=0x00;
		#if REFERENCE == EXTERNAL
		ADMUX &= ~(1<<REFS0)|(1<<REFS1);
		#endif
	
		#if REFERENCE == AVCC
		ADMUX |= (1<<REFS0);
		#endif
	
		#if REFERENCE == INTERNAL
		ADMUX |= (1<<REFS0)|(1<<REFS1);
		#endif
	
		ADMUX |= chan;
	
		//messung starten
		ADCSRA|=(1<<ADSC);
	break;
	}
	
	
	measurement++;
	if(measurement>3) measurement =1;
}

